Request

Response

    Sheets
    POST

    projects/{projectId}/sheets:batch-restore

    Restores deleted sheets. The sheet is restored to the version set it was associated with when it was deleted.

    Note that sheet numbers need to be unique within a version set. If you try to restore a sheet to a version set that includes an existing sheet with the same number, it will not restore the sheet. The errors object in the response gives information about unrestored sheets.

    To delete sheets, call POST sheets:batch-delete.

    Note that this endpoint is not compatible with BIM 360 projects.

    Resource Information

    Method and URI
    POST
    https://developer.api.autodesk.com/construction/sheets/v1/projects/{projectId}/sheets:batch-restore
    Authentication Context
    User context optional
    Required OAuth Scopes
    data:write
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a two-legged access token obtained via a Client Credentials Grant flow, or a three-legged access token obtained via an Authorization Code flow or a Secure Service Account (SSA) flow.

    The SSA flow is designed for headless server-to-server operations. While it functions like a two-legged flow (no user interaction), it is classified as three-legged because it preserves user context.

    x-user-id
    string
    The ID of the user on whose behalf the API request is made. This header is optional when using a 2-legged OAuth2, but required if using 2-legged OAuth2 with user impersonation.

    When using 2-legged OAuth2 without user impersonation, your app has access to all users defined by the administrator in the SaaS integrations UI. However, when user impersonation is enabled, the API call is restricted to act only on behalf of the specified user. This header is not relevant for 3-legged OAuth2.

    You can use either the user’s Forma ID (id), or their Autodesk ID (autodeskId).

    Content-Type*
    string
    Must be application/json
    * Required

    Request

    URI Parameters

    projectId
    string: UUID
    The ID of the project. Use the Data Management API to retrieve the project ID. For more information, see the Retrieve a Project ID tutorial. You can use a project ID either with a “b.” prefix or without a “b.” prefix. For instance, a project ID of “b.a4be0c34a-4ab7” can also be referred to as “a4be0c34a-4ab7”.

    Request

    Body Structure

    ids*
    array: string
    The IDs of the sheets to restore. To find the IDs of deleted sheets you want to restore, call GET sheets using the isDeleted=true filter.
    • The max number of items is 200.
    * Required

    Response

    HTTP Status Code Summary

    200
    OK
    Successfully restored sheets.
    400
    Bad Request
    The parameters of the requested operation are invalid.
    403
    Forbidden
    The user or client represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource cannot be found.
    409
    Conflict
    The request could not be completed due to a conflict with the current state of the target resource.
    429
    Too Many Requests
    The server has received too many requests.
    500
    Internal Server Error
    An unexpected error occurred on the server.

    Response

    Body Structure (200)

    Expand all
    results
    array: object
    The list of sheets that were successfully restored.
    id
    string: UUID
    The ID of the sheet.
    errors
    array: object
    The list of sheets that were not restored. Sheets are usually not restored because a sheet with the same number exists in the version set.
    sheetId
    string: UUID
    The ID of the sheet that was not restored.
    code
    string
    The code of the error.
    title
    string
    The title of the error.
    detail
    string
    Details about the error.

    Example

    Successfully restored sheets.

    Request

    curl -v 'https://developer.api.autodesk.com/construction/sheets/v1/projects/9ba6681e-1952-4d54-aac4-9de6d9858dd4/sheets:batch-restore' \
      -X 'POST' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
      -H 'Content-Type: application/json' \
      -d '{
            "ids": [
              "0d7a5883-1694-3078-a06d-ad24413f8b06"
            ]
          }'
    
    Show More

    Response

    {
      "results": [
        {
          "id": "0d7a5883-1694-3078-a06d-ad24413f8b06"
        }
      ],
      "errors": [
        {
          "sheetId": "",
          "code": "",
          "title": "",
          "detail": ""
        }
      ]
    }
    
    Show More